<?php

require './lib/component.php';
require './lib/filestorage.php';
require './lib/filerecordmanager.php';
$config = require('./config/file.php');

function extraImageCheck($rec)
{
	if (function_exists('getimagesize') && strpos($rec['type'], 'image/') === 0) {
		if (($s = @getimagesize($rec['target'])) === FALSE
		  || strpos($s['mime'], 'image/') !== 0
		  || empty($s[0])
		  || empty($s[1])) {
			return 'File is fake or broken';
		}
	}
	return NULL;
}

if ($_SERVER['REQUEST_METHOD'] == 'POST') {

	$subject = isset($_POST['subject']) ? $_POST['subject'] : '';

	$storage = new FileStorage($config);
	$storage->addEvent('onUpload', 'extraImageCheck');

	$num = $storage->upload('attach', $subject);
	$errors = $storage->getErrors();

	header('Content-type: text/html; charset=utf-8');

	if (!empty($errors)) {
		foreach ($errors as $error) {
			echo 'Error: ' . $error . "<br/>\n";
		}
	}
	if ($num) {

		$manager = new FileRecordManager(array('uploadDir' => $config['uploadDir']));
		$it = $manager->getIterator();

		echo "<p>Just uploaded:</p>\n<ul>";
		$newRecords = $storage->getRecords();
		foreach ($newRecords as $rec) {
			$it->append($rec);
			$key = $manager->lastKey();
			echo '<li><a href="' . $_SERVER['PHP_SELF'] . '?download=' . $key . '">' . htmlentities($rec['name'], ENT_QUOTES, 'UTF-8') . '</a> (' . $rec['type'] . ")</li><br/>\n";
		}
		$manager->close();
		echo "</ul><br/>\n";

	} else {

		echo "No files uploaded<br/>\n";

	}
	echo '<a href="' . $_SERVER['PHP_SELF'] . '">Add more<a> or <a href="' . $_SERVER['PHP_SELF'] . '?list">File list</a>';

} else if (isset($_GET['list'])) {

	header('Content-type: text/html; charset=utf-8');

	$manager = new FileRecordManager(array('uploadDir' => $config['uploadDir']));
	$it = $manager->getIterator();
	if ($it->count()) {
		echo "<p>File list:</p>\n<ul>";
		foreach ($it as $key => $rec)
		{
			echo '<li><a href="' . $_SERVER['PHP_SELF'] . '?download=' . $key . '">' . htmlentities($rec['name'], ENT_QUOTES, 'UTF-8') . '</a> (' . $rec['type'] . ')'
			   . ' <a href="' . $_SERVER['PHP_SELF'] . '?delete=' . $key. '">delete</a>'
			   . '<br/>"' . htmlentities($rec['subject'], ENT_QUOTES, 'UTF-8') . '", uploaded ' . date('Y-m-d H:i:s', $rec['uploaded'])
			   . "</li>\n";
		}
		echo "</ul><br/>\n";
	} else {
		echo "<p>Nothing uploaded yet</p>\n";
	}
	echo '<a href="' . $_SERVER['PHP_SELF'] . '">Add file<a>';


} else if (isset($_GET['download'])) {

	$key = intval($_GET['download']);

	$manager = new FileRecordManager(array('uploadDir' => $config['uploadDir']));
	$it = $manager->getIterator();
	if ($it->valid($key)) {
		$rec = $it->offsetGet($key);
		$storage = new FileStorage(array('uploadDir' => $config['uploadDir']));
		$storage->download($rec);
	}

} else if (isset($_GET['delete'])) {

	$key = intval($_GET['delete']);

	$manager = new FileRecordManager(array('uploadDir' => $config['uploadDir']));
	$it = $manager->getIterator();
	if ($it->valid($key)) {
		$rec = $it->offsetGet($key);
		$storage = new FileStorage(array('uploadDir' => $config['uploadDir']));
		$storage->delete($rec);
		$it->offsetUnset($key);
	}
	$manager->close();

	header('Location: ' . $_SERVER['PHP_SELF'] . '?list');

} else {

	header('Content-type: text/html; charset=utf-8');

?>
	<form method="post" action="<?php echo $_SERVER['PHP_SELF'] ?>" enctype="multipart/form-data">
		<fieldset>
		<input type="hidden" name="MAX_FILE_SIZE" value="<?php echo $config['maxFileSize'] ?>" />
		<p><label><strong>Subject</strong><br />
		<input type="text" name="subject" value="" size="80" maxlength="70" /></label></p>
		<p><input type="file" name="attach[]" size="50" /></p>
		<p><input type="file" name="attach[]" size="50" /></p>
		<p><input type="file" name="attach[]" size="50" /></p>
		</fieldset>
		<p><input type="submit" name="submit" value="Send" /></p>
		</form>

	</form>
	<a href="<?php echo $_SERVER['PHP_SELF'] ?>?list">List uploaded</a>
<?php

}
